#include "AbortControllerBinding.h"
#include "AbortSignalBinding.h"
#include "AddonManagerBinding.h"
#include "BrowsingContextBinding.h"
#include "ChannelWrapperBinding.h"
#include "ChromeUtilsBinding.h"
#include "ConsoleBinding.h"
#include "DOMErrorBinding.h"
#include "DOMExceptionBinding.h"
#include "DOMRequestBinding.h"
#include "DOMStringListBinding.h"
#include "DominatorTreeBinding.h"
#include "ErrorEventBinding.h"
#include "EventBinding.h"
#include "EventTargetBinding.h"
#include "FileReaderBinding.h"
#include "HeapSnapshotBinding.h"
#include "IDBCursorBinding.h"
#include "IDBDatabaseBinding.h"
#include "IDBFactoryBinding.h"
#include "IDBFileHandleBinding.h"
#include "IDBFileRequestBinding.h"
#include "IDBIndexBinding.h"
#include "IDBKeyRangeBinding.h"
#include "IDBMutableFileBinding.h"
#include "IDBObjectStoreBinding.h"
#include "IDBOpenDBRequestBinding.h"
#include "IDBRequestBinding.h"
#include "IDBTransactionBinding.h"
#include "IDBVersionChangeEventBinding.h"
#include "IdleDeadlineBinding.h"
#include "MatchGlobBinding.h"
#include "MatchPatternBinding.h"
#include "MessageChannelBinding.h"
#include "MessageEventBinding.h"
#include "MessagePortBinding.h"
#include "MozDocumentObserverBinding.h"
#include "PlacesEventBinding.h"
#include "PlacesObserversBinding.h"
#include "PrecompiledScriptBinding.h"
#include "PrioEncoderBinding.h"
#include "PromiseDebuggingBinding.h"
#include "StreamFilterBinding.h"
#include "StreamFilterDataEventBinding.h"
#include "StructuredCloneHolderBinding.h"
#include "TCPServerSocketBinding.h"
#include "TCPServerSocketEventBinding.h"
#include "TCPSocketBinding.h"
#include "TCPSocketErrorEventBinding.h"
#include "TCPSocketEventBinding.h"
#include "TextDecoderBinding.h"
#include "TextEncoderBinding.h"
#include "URLSearchParamsBinding.h"
#include "WebExtensionContentScriptBinding.h"
#include "WebExtensionPolicyBinding.h"
#include "WorkerBinding.h"
#include "js/Id.h"
#include "mozilla/dom/WebIDLGlobalNameHash.h"
#include "nsThreadUtils.h"

namespace mozilla {
namespace dom {
static const char *IdString(unsigned int aIndex)
{
  static const char table[] = "AbortController" "\0" "AbortSignal" "\0" "AddonManagerPermissions" "\0" "BrowsingContext" "\0" "ChannelWrapper" "\0" "ChromeUtils" "\0" "ChromeWorker" "\0" "ConsoleInstance" "\0" "DOMError" "\0" "DOMException" "\0" "DOMRequest" "\0" "DOMStringList" "\0" "DominatorTree" "\0" "ErrorEvent" "\0" "Event" "\0" "EventTarget" "\0" "FileReader" "\0" "HeapSnapshot" "\0" "IDBCursor" "\0" "IDBCursorWithValue" "\0" "IDBDatabase" "\0" "IDBFactory" "\0" "IDBFileHandle" "\0" "IDBFileRequest" "\0" "IDBIndex" "\0" "IDBKeyRange" "\0" "IDBLocaleAwareKeyRange" "\0" "IDBMutableFile" "\0" "IDBObjectStore" "\0" "IDBOpenDBRequest" "\0" "IDBRequest" "\0" "IDBTransaction" "\0" "IDBVersionChangeEvent" "\0" "IdleDeadline" "\0" "MatchGlob" "\0" "MatchPattern" "\0" "MatchPatternSet" "\0" "MessageChannel" "\0" "MessageEvent" "\0" "MessagePort" "\0" "MozDocumentMatcher" "\0" "MozDocumentObserver" "\0" "MozQueryInterface" "\0" "PlacesEvent" "\0" "PlacesObservers" "\0" "PlacesVisit" "\0" "PlacesWeakCallbackWrapper" "\0" "PrecompiledScript" "\0" "PrioEncoder" "\0" "PromiseDebugging" "\0" "StreamFilter" "\0" "StreamFilterDataEvent" "\0" "StructuredCloneHolder" "\0" "TCPServerSocket" "\0" "TCPServerSocketEvent" "\0" "TCPSocket" "\0" "TCPSocketErrorEvent" "\0" "TCPSocketEvent" "\0" "TextDecoder" "\0" "TextEncoder" "\0" "URLSearchParams" "\0" "WebExtensionContentScript" "\0" "WebExtensionPolicy" "\0" "Worker" "\0" "console";
  static const uint16_t indices[] = { 0, 16, 28, 52, 68, 83, 95, 108, 124, 133, 146, 157, 171, 185, 196, 202, 214, 225, 238, 248, 267, 279, 290, 304, 319, 328, 340, 363, 378, 393, 410, 421, 436, 458, 471, 481, 494, 510, 525, 538, 550, 569, 589, 607, 619, 635, 647, 673, 691, 703, 720, 733, 755, 777, 793, 814, 824, 844, 859, 871, 883, 899, 925, 944, 951 };
  static_assert(959 <= UINT16_MAX, "string table overflow!");
  return &table[indices[aIndex]];
}

struct SystemProperty
{
  WebIDLGlobalNameHash::ConstructorEnabled enabled;
  ProtoGetter define;
  PinnedStringId id;
};

static SystemProperty properties[] = {
  { nullptr, AbortController_Binding::GetConstructorObject },
  { nullptr, AbortSignal_Binding::GetConstructorObject },
  { AddonManagerPermissions_Binding::ConstructorEnabled, AddonManagerPermissions_Binding::GetConstructorObject },
  { BrowsingContext_Binding::ConstructorEnabled, BrowsingContext_Binding::GetConstructorObject },
  { ChannelWrapper_Binding::ConstructorEnabled, ChannelWrapper_Binding::GetConstructorObject },
  { ChromeUtils_Binding::ConstructorEnabled, ChromeUtils_Binding::GetConstructorObject },
  { ChromeWorker_Binding::ConstructorEnabled, ChromeWorker_Binding::GetConstructorObject },
  { ConsoleInstance_Binding::ConstructorEnabled, ConsoleInstance_Binding::GetConstructorObject },
  { nullptr, DOMError_Binding::GetConstructorObject },
  { nullptr, DOMException_Binding::GetConstructorObject },
  { nullptr, DOMRequest_Binding::GetConstructorObject },
  { nullptr, DOMStringList_Binding::GetConstructorObject },
  { DominatorTree_Binding::ConstructorEnabled, DominatorTree_Binding::GetConstructorObject },
  { nullptr, ErrorEvent_Binding::GetConstructorObject },
  { nullptr, Event_Binding::GetConstructorObject },
  { nullptr, EventTarget_Binding::GetConstructorObject },
  { nullptr, FileReader_Binding::GetConstructorObject },
  { HeapSnapshot_Binding::ConstructorEnabled, HeapSnapshot_Binding::GetConstructorObject },
  { nullptr, IDBCursor_Binding::GetConstructorObject },
  { nullptr, IDBCursorWithValue_Binding::GetConstructorObject },
  { nullptr, IDBDatabase_Binding::GetConstructorObject },
  { nullptr, IDBFactory_Binding::GetConstructorObject },
  { nullptr, IDBFileHandle_Binding::GetConstructorObject },
  { nullptr, IDBFileRequest_Binding::GetConstructorObject },
  { nullptr, IDBIndex_Binding::GetConstructorObject },
  { nullptr, IDBKeyRange_Binding::GetConstructorObject },
  { IDBLocaleAwareKeyRange_Binding::ConstructorEnabled, IDBLocaleAwareKeyRange_Binding::GetConstructorObject },
  { nullptr, IDBMutableFile_Binding::GetConstructorObject },
  { nullptr, IDBObjectStore_Binding::GetConstructorObject },
  { nullptr, IDBOpenDBRequest_Binding::GetConstructorObject },
  { nullptr, IDBRequest_Binding::GetConstructorObject },
  { nullptr, IDBTransaction_Binding::GetConstructorObject },
  { nullptr, IDBVersionChangeEvent_Binding::GetConstructorObject },
  { IdleDeadline_Binding::ConstructorEnabled, IdleDeadline_Binding::GetConstructorObject },
  { MatchGlob_Binding::ConstructorEnabled, MatchGlob_Binding::GetConstructorObject },
  { MatchPattern_Binding::ConstructorEnabled, MatchPattern_Binding::GetConstructorObject },
  { MatchPatternSet_Binding::ConstructorEnabled, MatchPatternSet_Binding::GetConstructorObject },
  { nullptr, MessageChannel_Binding::GetConstructorObject },
  { nullptr, MessageEvent_Binding::GetConstructorObject },
  { nullptr, MessagePort_Binding::GetConstructorObject },
  { MozDocumentMatcher_Binding::ConstructorEnabled, MozDocumentMatcher_Binding::GetConstructorObject },
  { MozDocumentObserver_Binding::ConstructorEnabled, MozDocumentObserver_Binding::GetConstructorObject },
  { MozQueryInterface_Binding::ConstructorEnabled, MozQueryInterface_Binding::GetConstructorObject },
  { PlacesEvent_Binding::ConstructorEnabled, PlacesEvent_Binding::GetConstructorObject },
  { PlacesObservers_Binding::ConstructorEnabled, PlacesObservers_Binding::GetConstructorObject },
  { PlacesVisit_Binding::ConstructorEnabled, PlacesVisit_Binding::GetConstructorObject },
  { PlacesWeakCallbackWrapper_Binding::ConstructorEnabled, PlacesWeakCallbackWrapper_Binding::GetConstructorObject },
  { PrecompiledScript_Binding::ConstructorEnabled, PrecompiledScript_Binding::GetConstructorObject },
  { PrioEncoder_Binding::ConstructorEnabled, PrioEncoder_Binding::GetConstructorObject },
  { PromiseDebugging_Binding::ConstructorEnabled, PromiseDebugging_Binding::GetConstructorObject },
  { StreamFilter_Binding::ConstructorEnabled, StreamFilter_Binding::GetConstructorObject },
  { StreamFilterDataEvent_Binding::ConstructorEnabled, StreamFilterDataEvent_Binding::GetConstructorObject },
  { StructuredCloneHolder_Binding::ConstructorEnabled, StructuredCloneHolder_Binding::GetConstructorObject },
  { TCPServerSocket_Binding::ConstructorEnabled, TCPServerSocket_Binding::GetConstructorObject },
  { TCPServerSocketEvent_Binding::ConstructorEnabled, TCPServerSocketEvent_Binding::GetConstructorObject },
  { TCPSocket_Binding::ConstructorEnabled, TCPSocket_Binding::GetConstructorObject },
  { TCPSocketErrorEvent_Binding::ConstructorEnabled, TCPSocketErrorEvent_Binding::GetConstructorObject },
  { TCPSocketEvent_Binding::ConstructorEnabled, TCPSocketEvent_Binding::GetConstructorObject },
  { nullptr, TextDecoder_Binding::GetConstructorObject },
  { nullptr, TextEncoder_Binding::GetConstructorObject },
  { nullptr, URLSearchParams_Binding::GetConstructorObject },
  { WebExtensionContentScript_Binding::ConstructorEnabled, WebExtensionContentScript_Binding::GetConstructorObject },
  { WebExtensionPolicy_Binding::ConstructorEnabled, WebExtensionPolicy_Binding::GetConstructorObject },
  { Worker_Binding::ConstructorEnabled, Worker_Binding::GetConstructorObject },
  { nullptr, console_Binding::GetConstructorObject },
};

static bool idsInited = false;

bool
SystemBindingInitIds(JSContext* aCx)
{
  MOZ_ASSERT(NS_IsMainThread());

  if (!idsInited) {
    // We can't use range-based for because we need the index to call IdString.
    for (uint32_t i = 0; i < ArrayLength(properties); ++i) {
      if (!properties[i].id.init(aCx, IdString(i))) {
        return false;
      }
    }
    idsInited = true;
  }

  return true;
}

bool
ResolveSystemBinding(JSContext* aCx, JS::Handle<JSObject*> aObj, JS::Handle<jsid> aId, bool* aResolvedp)
{
  MOZ_ASSERT(NS_IsMainThread());
  MOZ_ASSERT(idsInited);

  if (JSID_IS_VOID(aId)) {
    for (const auto& property : properties) {
      if (!property.enabled || property.enabled(aCx, aObj)) {
        if (!property.define(aCx)) {
          return false;
        }
        *aResolvedp = true;
      }
    }
    return true;
  }

  for (const auto& property : properties) {
    if (property.id == aId) {
      if (!property.enabled || property.enabled(aCx, aObj)) {
        if (!property.define(aCx)) {
          return false;
        }
        *aResolvedp = true;
        break;
      }
    }
  }
  return true;
}

bool
MayResolveAsSystemBindingName(jsid aId)
{
  MOZ_ASSERT(NS_IsMainThread());
  MOZ_ASSERT(idsInited);

  for (const auto& property : properties) {
    if (aId == property.id) {
      return true;
    }
  }
  return false;
}

void
GetSystemBindingNames(JSContext* aCx, JS::Handle<JSObject*> aObj, JS::AutoIdVector& aNames, bool aEnumerableOnly, mozilla::ErrorResult& aRv)
{
  MOZ_ASSERT(NS_IsMainThread());

  if (aEnumerableOnly) {
    return;
  }

  if (!SystemBindingInitIds(aCx)) {
    aRv.NoteJSContextException(aCx);
    return;
  }

  for (const auto& property : properties) {
    if (!property.enabled || property.enabled(aCx, aObj)) {
      if (!aNames.append(property.id)) {
        aRv.Throw(NS_ERROR_OUT_OF_MEMORY);
        return;
      }
    }
  }
}

} // namespace dom
} // namespace mozilla

