//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebAuthnTransaction_h
#define PWebAuthnTransaction_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "ipc/IPCMessageUtils.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "nsTHashtable.h"
#include "mozilla/OperatorNewExtensions.h"

// Headers for typedefs
#include "ipc/IPCMessageUtils.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnAuthenticatorSelection|
//
namespace mozilla {
namespace dom {
class WebAuthnAuthenticatorSelection final
{
private:

public:
    MOZ_IMPLICIT WebAuthnAuthenticatorSelection() :
        requireResidentKey_(),
        requireUserVerification_(),
        requirePlatformAttachment_()
    {
    }

    MOZ_IMPLICIT WebAuthnAuthenticatorSelection(
            const bool& _requireResidentKey,
            const bool& _requireUserVerification,
            const bool& _requirePlatformAttachment) :
        requireResidentKey_(_requireResidentKey),
        requireUserVerification_(_requireUserVerification),
        requirePlatformAttachment_(_requirePlatformAttachment)
    {
    }

    bool
    operator==(const WebAuthnAuthenticatorSelection& _o) const;

    bool
    operator!=(const WebAuthnAuthenticatorSelection& _o) const;

    bool&
    requireResidentKey()
    {
        return requireResidentKey_;
    }
    const bool&
    requireResidentKey() const
    {
        return requireResidentKey_;
    }

    bool&
    requireUserVerification()
    {
        return requireUserVerification_;
    }
    const bool&
    requireUserVerification() const
    {
        return requireUserVerification_;
    }

    bool&
    requirePlatformAttachment()
    {
        return requirePlatformAttachment_;
    }
    const bool&
    requirePlatformAttachment() const
    {
        return requirePlatformAttachment_;
    }

private:
    bool requireResidentKey_;
    bool requireUserVerification_;
    bool requirePlatformAttachment_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnAuthenticatorSelection>
{
    typedef mozilla::dom::WebAuthnAuthenticatorSelection paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnScopedCredential|
//
namespace mozilla {
namespace dom {
class WebAuthnScopedCredential final
{
private:

public:
    MOZ_IMPLICIT WebAuthnScopedCredential() :
        id_(),
        transports_()
    {
    }

    MOZ_IMPLICIT WebAuthnScopedCredential(
            const nsTArray<uint8_t>& _id,
            const uint8_t& _transports) :
        id_(_id),
        transports_(_transports)
    {
    }

    bool
    operator==(const WebAuthnScopedCredential& _o) const;

    bool
    operator!=(const WebAuthnScopedCredential& _o) const;

    nsTArray<uint8_t>&
    id()
    {
        return id_;
    }
    const nsTArray<uint8_t>&
    id() const
    {
        return id_;
    }

    uint8_t&
    transports()
    {
        return transports_;
    }
    const uint8_t&
    transports() const
    {
        return transports_;
    }

private:
    nsTArray<uint8_t> id_;
    uint8_t transports_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnScopedCredential>
{
    typedef mozilla::dom::WebAuthnScopedCredential paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnExtensionAppId|
//
namespace mozilla {
namespace dom {
class WebAuthnExtensionAppId final
{
private:

public:
    MOZ_IMPLICIT WebAuthnExtensionAppId() :
        AppId_()
    {
    }

    MOZ_IMPLICIT WebAuthnExtensionAppId(const nsTArray<uint8_t>& _AppId) :
        AppId_(_AppId)
    {
    }

    bool
    operator==(const WebAuthnExtensionAppId& _o) const;

    bool
    operator!=(const WebAuthnExtensionAppId& _o) const;

    nsTArray<uint8_t>&
    AppId()
    {
        return AppId_;
    }
    const nsTArray<uint8_t>&
    AppId() const
    {
        return AppId_;
    }

private:
    nsTArray<uint8_t> AppId_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnExtensionAppId>
{
    typedef mozilla::dom::WebAuthnExtensionAppId paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union WebAuthnExtension|
//
namespace mozilla {
namespace dom {
class WebAuthnExtension final
{
public:
    enum Type {
        T__None,
        TWebAuthnExtensionAppId = 1,
        T__Last = TWebAuthnExtensionAppId
    };

private:
    typedef mozilla::dom::WebAuthnExtensionAppId WebAuthnExtensionAppId;
    typedef WebAuthnExtensionAppId WebAuthnExtensionAppId__tdef;

    union Value {
        mozilla::AlignedStorage2<WebAuthnExtensionAppId> VWebAuthnExtensionAppId;
    };

    WebAuthnExtensionAppId*
    ptr_WebAuthnExtensionAppId()
    {
        return ((mValue).VWebAuthnExtensionAppId).addr();
    }
    const WebAuthnExtensionAppId*
    constptr_WebAuthnExtensionAppId() const
    {
        return ((mValue).VWebAuthnExtensionAppId).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT WebAuthnExtension() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT WebAuthnExtension(const WebAuthnExtensionAppId& aOther);

    MOZ_IMPLICIT WebAuthnExtension(WebAuthnExtensionAppId&& aOther);

    MOZ_IMPLICIT WebAuthnExtension(const WebAuthnExtension& aOther);

    MOZ_IMPLICIT WebAuthnExtension(WebAuthnExtension&& aOther);

    ~WebAuthnExtension();

    Type
    type() const
    {
        return mType;
    }

    WebAuthnExtension&
    operator=(const WebAuthnExtensionAppId& aRhs);

    WebAuthnExtension&
    operator=(WebAuthnExtensionAppId&& aRhs);

    WebAuthnExtension&
    operator=(const WebAuthnExtension& aRhs);

    WebAuthnExtension&
    operator=(WebAuthnExtension&& aRhs);

    bool
    operator==(const WebAuthnExtensionAppId& aRhs) const;

    bool
    operator==(const WebAuthnExtension& aRhs) const;

    WebAuthnExtensionAppId&
    get_WebAuthnExtensionAppId()
    {
        AssertSanity(TWebAuthnExtensionAppId);
        return (*(ptr_WebAuthnExtensionAppId()));
    }
    const WebAuthnExtensionAppId&
    get_WebAuthnExtensionAppId() const
    {
        AssertSanity(TWebAuthnExtensionAppId);
        return (*(constptr_WebAuthnExtensionAppId()));
    }
    void
    get(WebAuthnExtensionAppId* aOutValue) const;
    operator WebAuthnExtensionAppId&()
    {
        return get_WebAuthnExtensionAppId();
    }
    operator const WebAuthnExtensionAppId&() const
    {
        return get_WebAuthnExtensionAppId();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnExtension>
{
    typedef mozilla::dom::WebAuthnExtension paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnExtensionResultAppId|
//
namespace mozilla {
namespace dom {
class WebAuthnExtensionResultAppId final
{
private:

public:
    MOZ_IMPLICIT WebAuthnExtensionResultAppId() :
        AppId_()
    {
    }

    MOZ_IMPLICIT WebAuthnExtensionResultAppId(const bool& _AppId) :
        AppId_(_AppId)
    {
    }

    bool
    operator==(const WebAuthnExtensionResultAppId& _o) const;

    bool
    operator!=(const WebAuthnExtensionResultAppId& _o) const;

    bool&
    AppId()
    {
        return AppId_;
    }
    const bool&
    AppId() const
    {
        return AppId_;
    }

private:
    bool AppId_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnExtensionResultAppId>
{
    typedef mozilla::dom::WebAuthnExtensionResultAppId paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union WebAuthnExtensionResult|
//
namespace mozilla {
namespace dom {
class WebAuthnExtensionResult final
{
public:
    enum Type {
        T__None,
        TWebAuthnExtensionResultAppId = 1,
        T__Last = TWebAuthnExtensionResultAppId
    };

private:
    typedef mozilla::dom::WebAuthnExtensionResultAppId WebAuthnExtensionResultAppId;
    typedef WebAuthnExtensionResultAppId WebAuthnExtensionResultAppId__tdef;

    union Value {
        mozilla::AlignedStorage2<WebAuthnExtensionResultAppId> VWebAuthnExtensionResultAppId;
    };

    WebAuthnExtensionResultAppId*
    ptr_WebAuthnExtensionResultAppId()
    {
        return ((mValue).VWebAuthnExtensionResultAppId).addr();
    }
    const WebAuthnExtensionResultAppId*
    constptr_WebAuthnExtensionResultAppId() const
    {
        return ((mValue).VWebAuthnExtensionResultAppId).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT WebAuthnExtensionResult() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT WebAuthnExtensionResult(const WebAuthnExtensionResultAppId& aOther);

    MOZ_IMPLICIT WebAuthnExtensionResult(WebAuthnExtensionResultAppId&& aOther);

    MOZ_IMPLICIT WebAuthnExtensionResult(const WebAuthnExtensionResult& aOther);

    MOZ_IMPLICIT WebAuthnExtensionResult(WebAuthnExtensionResult&& aOther);

    ~WebAuthnExtensionResult();

    Type
    type() const
    {
        return mType;
    }

    WebAuthnExtensionResult&
    operator=(const WebAuthnExtensionResultAppId& aRhs);

    WebAuthnExtensionResult&
    operator=(WebAuthnExtensionResultAppId&& aRhs);

    WebAuthnExtensionResult&
    operator=(const WebAuthnExtensionResult& aRhs);

    WebAuthnExtensionResult&
    operator=(WebAuthnExtensionResult&& aRhs);

    bool
    operator==(const WebAuthnExtensionResultAppId& aRhs) const;

    bool
    operator==(const WebAuthnExtensionResult& aRhs) const;

    WebAuthnExtensionResultAppId&
    get_WebAuthnExtensionResultAppId()
    {
        AssertSanity(TWebAuthnExtensionResultAppId);
        return (*(ptr_WebAuthnExtensionResultAppId()));
    }
    const WebAuthnExtensionResultAppId&
    get_WebAuthnExtensionResultAppId() const
    {
        AssertSanity(TWebAuthnExtensionResultAppId);
        return (*(constptr_WebAuthnExtensionResultAppId()));
    }
    void
    get(WebAuthnExtensionResultAppId* aOutValue) const;
    operator WebAuthnExtensionResultAppId&()
    {
        return get_WebAuthnExtensionResultAppId();
    }
    operator const WebAuthnExtensionResultAppId&() const
    {
        return get_WebAuthnExtensionResultAppId();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnExtensionResult>
{
    typedef mozilla::dom::WebAuthnExtensionResult paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnMakeCredentialExtraInfo|
//
namespace mozilla {
namespace dom {
class WebAuthnMakeCredentialExtraInfo final
{
private:
    typedef mozilla::dom::WebAuthnExtension WebAuthnExtension;
    typedef mozilla::dom::WebAuthnAuthenticatorSelection WebAuthnAuthenticatorSelection;

public:
    MOZ_IMPLICIT WebAuthnMakeCredentialExtraInfo() :
        Extensions_(),
        AuthenticatorSelection_(),
        RequestDirectAttestation_()
    {
    }

    MOZ_IMPLICIT WebAuthnMakeCredentialExtraInfo(
            const nsTArray<WebAuthnExtension>& _Extensions,
            const WebAuthnAuthenticatorSelection& _AuthenticatorSelection,
            const bool& _RequestDirectAttestation) :
        Extensions_(_Extensions),
        AuthenticatorSelection_(_AuthenticatorSelection),
        RequestDirectAttestation_(_RequestDirectAttestation)
    {
    }

    bool
    operator==(const WebAuthnMakeCredentialExtraInfo& _o) const;

    bool
    operator!=(const WebAuthnMakeCredentialExtraInfo& _o) const;

    nsTArray<WebAuthnExtension>&
    Extensions()
    {
        return Extensions_;
    }
    const nsTArray<WebAuthnExtension>&
    Extensions() const
    {
        return Extensions_;
    }

    WebAuthnAuthenticatorSelection&
    AuthenticatorSelection()
    {
        return AuthenticatorSelection_;
    }
    const WebAuthnAuthenticatorSelection&
    AuthenticatorSelection() const
    {
        return AuthenticatorSelection_;
    }

    bool&
    RequestDirectAttestation()
    {
        return RequestDirectAttestation_;
    }
    const bool&
    RequestDirectAttestation() const
    {
        return RequestDirectAttestation_;
    }

private:
    nsTArray<WebAuthnExtension> Extensions_;
    WebAuthnAuthenticatorSelection AuthenticatorSelection_;
    bool RequestDirectAttestation_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnMakeCredentialExtraInfo>
{
    typedef mozilla::dom::WebAuthnMakeCredentialExtraInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union WebAuthnMaybeMakeCredentialExtraInfo|
//
namespace mozilla {
namespace dom {
class WebAuthnMaybeMakeCredentialExtraInfo final
{
public:
    enum Type {
        T__None,
        TWebAuthnMakeCredentialExtraInfo = 1,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::dom::WebAuthnMakeCredentialExtraInfo WebAuthnMakeCredentialExtraInfo;
    typedef mozilla::null_t null_t;
    typedef WebAuthnMakeCredentialExtraInfo WebAuthnMakeCredentialExtraInfo__tdef;
    typedef null_t null_t__tdef;

    union Value {
        mozilla::AlignedStorage2<WebAuthnMakeCredentialExtraInfo> VWebAuthnMakeCredentialExtraInfo;
        mozilla::AlignedStorage2<null_t> Vnull_t;
    };

    WebAuthnMakeCredentialExtraInfo*
    ptr_WebAuthnMakeCredentialExtraInfo()
    {
        return ((mValue).VWebAuthnMakeCredentialExtraInfo).addr();
    }
    const WebAuthnMakeCredentialExtraInfo*
    constptr_WebAuthnMakeCredentialExtraInfo() const
    {
        return ((mValue).VWebAuthnMakeCredentialExtraInfo).addr();
    }
    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT WebAuthnMaybeMakeCredentialExtraInfo() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT WebAuthnMaybeMakeCredentialExtraInfo(const WebAuthnMakeCredentialExtraInfo& aOther);

    MOZ_IMPLICIT WebAuthnMaybeMakeCredentialExtraInfo(WebAuthnMakeCredentialExtraInfo&& aOther);

    MOZ_IMPLICIT WebAuthnMaybeMakeCredentialExtraInfo(const null_t& aOther);

    MOZ_IMPLICIT WebAuthnMaybeMakeCredentialExtraInfo(null_t&& aOther);

    MOZ_IMPLICIT WebAuthnMaybeMakeCredentialExtraInfo(const WebAuthnMaybeMakeCredentialExtraInfo& aOther);

    MOZ_IMPLICIT WebAuthnMaybeMakeCredentialExtraInfo(WebAuthnMaybeMakeCredentialExtraInfo&& aOther);

    ~WebAuthnMaybeMakeCredentialExtraInfo();

    Type
    type() const
    {
        return mType;
    }

    WebAuthnMaybeMakeCredentialExtraInfo&
    operator=(const WebAuthnMakeCredentialExtraInfo& aRhs);

    WebAuthnMaybeMakeCredentialExtraInfo&
    operator=(WebAuthnMakeCredentialExtraInfo&& aRhs);

    WebAuthnMaybeMakeCredentialExtraInfo&
    operator=(const null_t& aRhs);

    WebAuthnMaybeMakeCredentialExtraInfo&
    operator=(null_t&& aRhs);

    WebAuthnMaybeMakeCredentialExtraInfo&
    operator=(const WebAuthnMaybeMakeCredentialExtraInfo& aRhs);

    WebAuthnMaybeMakeCredentialExtraInfo&
    operator=(WebAuthnMaybeMakeCredentialExtraInfo&& aRhs);

    bool
    operator==(const WebAuthnMakeCredentialExtraInfo& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const WebAuthnMaybeMakeCredentialExtraInfo& aRhs) const;

    WebAuthnMakeCredentialExtraInfo&
    get_WebAuthnMakeCredentialExtraInfo()
    {
        AssertSanity(TWebAuthnMakeCredentialExtraInfo);
        return (*(ptr_WebAuthnMakeCredentialExtraInfo()));
    }
    const WebAuthnMakeCredentialExtraInfo&
    get_WebAuthnMakeCredentialExtraInfo() const
    {
        AssertSanity(TWebAuthnMakeCredentialExtraInfo);
        return (*(constptr_WebAuthnMakeCredentialExtraInfo()));
    }
    void
    get(WebAuthnMakeCredentialExtraInfo* aOutValue) const;
    operator WebAuthnMakeCredentialExtraInfo&()
    {
        return get_WebAuthnMakeCredentialExtraInfo();
    }
    operator const WebAuthnMakeCredentialExtraInfo&() const
    {
        return get_WebAuthnMakeCredentialExtraInfo();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnMaybeMakeCredentialExtraInfo>
{
    typedef mozilla::dom::WebAuthnMaybeMakeCredentialExtraInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnMakeCredentialInfo|
//
namespace mozilla {
namespace dom {
class WebAuthnMakeCredentialInfo final
{
private:
    typedef mozilla::dom::WebAuthnScopedCredential WebAuthnScopedCredential;
    typedef mozilla::dom::WebAuthnMaybeMakeCredentialExtraInfo WebAuthnMaybeMakeCredentialExtraInfo;

public:
    MOZ_IMPLICIT WebAuthnMakeCredentialInfo() :
        Origin_(),
        RpId_(),
        Challenge_(),
        ClientDataJSON_(),
        TimeoutMS_(),
        ExcludeList_(),
        Extra_()
    {
    }

    MOZ_IMPLICIT WebAuthnMakeCredentialInfo(
            const nsString& _Origin,
            const nsString& _RpId,
            const nsTArray<uint8_t>& _Challenge,
            const nsCString& _ClientDataJSON,
            const uint32_t& _TimeoutMS,
            const nsTArray<WebAuthnScopedCredential>& _ExcludeList,
            const WebAuthnMaybeMakeCredentialExtraInfo& _Extra) :
        Origin_(_Origin),
        RpId_(_RpId),
        Challenge_(_Challenge),
        ClientDataJSON_(_ClientDataJSON),
        TimeoutMS_(_TimeoutMS),
        ExcludeList_(_ExcludeList),
        Extra_(_Extra)
    {
    }

    bool
    operator==(const WebAuthnMakeCredentialInfo& _o) const;

    bool
    operator!=(const WebAuthnMakeCredentialInfo& _o) const;

    nsString&
    Origin()
    {
        return Origin_;
    }
    const nsString&
    Origin() const
    {
        return Origin_;
    }

    nsString&
    RpId()
    {
        return RpId_;
    }
    const nsString&
    RpId() const
    {
        return RpId_;
    }

    nsTArray<uint8_t>&
    Challenge()
    {
        return Challenge_;
    }
    const nsTArray<uint8_t>&
    Challenge() const
    {
        return Challenge_;
    }

    nsCString&
    ClientDataJSON()
    {
        return ClientDataJSON_;
    }
    const nsCString&
    ClientDataJSON() const
    {
        return ClientDataJSON_;
    }

    uint32_t&
    TimeoutMS()
    {
        return TimeoutMS_;
    }
    const uint32_t&
    TimeoutMS() const
    {
        return TimeoutMS_;
    }

    nsTArray<WebAuthnScopedCredential>&
    ExcludeList()
    {
        return ExcludeList_;
    }
    const nsTArray<WebAuthnScopedCredential>&
    ExcludeList() const
    {
        return ExcludeList_;
    }

    WebAuthnMaybeMakeCredentialExtraInfo&
    Extra()
    {
        return Extra_;
    }
    const WebAuthnMaybeMakeCredentialExtraInfo&
    Extra() const
    {
        return Extra_;
    }

private:
    nsString Origin_;
    nsString RpId_;
    nsTArray<uint8_t> Challenge_;
    nsCString ClientDataJSON_;
    uint32_t TimeoutMS_;
    nsTArray<WebAuthnScopedCredential> ExcludeList_;
    WebAuthnMaybeMakeCredentialExtraInfo Extra_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnMakeCredentialInfo>
{
    typedef mozilla::dom::WebAuthnMakeCredentialInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnMakeCredentialResult|
//
namespace mozilla {
namespace dom {
class WebAuthnMakeCredentialResult final
{
private:

public:
    MOZ_IMPLICIT WebAuthnMakeCredentialResult() :
        ClientDataJSON_(),
        AttestationObject_(),
        KeyHandle_(),
        RegistrationData_()
    {
    }

    MOZ_IMPLICIT WebAuthnMakeCredentialResult(
            const nsCString& _ClientDataJSON,
            const nsTArray<uint8_t>& _AttestationObject,
            const nsTArray<uint8_t>& _KeyHandle,
            const nsTArray<uint8_t>& _RegistrationData) :
        ClientDataJSON_(_ClientDataJSON),
        AttestationObject_(_AttestationObject),
        KeyHandle_(_KeyHandle),
        RegistrationData_(_RegistrationData)
    {
    }

    bool
    operator==(const WebAuthnMakeCredentialResult& _o) const;

    bool
    operator!=(const WebAuthnMakeCredentialResult& _o) const;

    nsCString&
    ClientDataJSON()
    {
        return ClientDataJSON_;
    }
    const nsCString&
    ClientDataJSON() const
    {
        return ClientDataJSON_;
    }

    nsTArray<uint8_t>&
    AttestationObject()
    {
        return AttestationObject_;
    }
    const nsTArray<uint8_t>&
    AttestationObject() const
    {
        return AttestationObject_;
    }

    nsTArray<uint8_t>&
    KeyHandle()
    {
        return KeyHandle_;
    }
    const nsTArray<uint8_t>&
    KeyHandle() const
    {
        return KeyHandle_;
    }

    nsTArray<uint8_t>&
    RegistrationData()
    {
        return RegistrationData_;
    }
    const nsTArray<uint8_t>&
    RegistrationData() const
    {
        return RegistrationData_;
    }

private:
    nsCString ClientDataJSON_;
    nsTArray<uint8_t> AttestationObject_;
    nsTArray<uint8_t> KeyHandle_;
    nsTArray<uint8_t> RegistrationData_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnMakeCredentialResult>
{
    typedef mozilla::dom::WebAuthnMakeCredentialResult paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnGetAssertionExtraInfo|
//
namespace mozilla {
namespace dom {
class WebAuthnGetAssertionExtraInfo final
{
private:
    typedef mozilla::dom::WebAuthnExtension WebAuthnExtension;

public:
    MOZ_IMPLICIT WebAuthnGetAssertionExtraInfo() :
        Extensions_(),
        RequireUserVerification_()
    {
    }

    MOZ_IMPLICIT WebAuthnGetAssertionExtraInfo(
            const nsTArray<WebAuthnExtension>& _Extensions,
            const bool& _RequireUserVerification) :
        Extensions_(_Extensions),
        RequireUserVerification_(_RequireUserVerification)
    {
    }

    bool
    operator==(const WebAuthnGetAssertionExtraInfo& _o) const;

    bool
    operator!=(const WebAuthnGetAssertionExtraInfo& _o) const;

    nsTArray<WebAuthnExtension>&
    Extensions()
    {
        return Extensions_;
    }
    const nsTArray<WebAuthnExtension>&
    Extensions() const
    {
        return Extensions_;
    }

    bool&
    RequireUserVerification()
    {
        return RequireUserVerification_;
    }
    const bool&
    RequireUserVerification() const
    {
        return RequireUserVerification_;
    }

private:
    nsTArray<WebAuthnExtension> Extensions_;
    bool RequireUserVerification_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnGetAssertionExtraInfo>
{
    typedef mozilla::dom::WebAuthnGetAssertionExtraInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union WebAuthnMaybeGetAssertionExtraInfo|
//
namespace mozilla {
namespace dom {
class WebAuthnMaybeGetAssertionExtraInfo final
{
public:
    enum Type {
        T__None,
        TWebAuthnGetAssertionExtraInfo = 1,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::dom::WebAuthnGetAssertionExtraInfo WebAuthnGetAssertionExtraInfo;
    typedef mozilla::null_t null_t;
    typedef WebAuthnGetAssertionExtraInfo WebAuthnGetAssertionExtraInfo__tdef;
    typedef null_t null_t__tdef;

    union Value {
        mozilla::AlignedStorage2<WebAuthnGetAssertionExtraInfo> VWebAuthnGetAssertionExtraInfo;
        mozilla::AlignedStorage2<null_t> Vnull_t;
    };

    WebAuthnGetAssertionExtraInfo*
    ptr_WebAuthnGetAssertionExtraInfo()
    {
        return ((mValue).VWebAuthnGetAssertionExtraInfo).addr();
    }
    const WebAuthnGetAssertionExtraInfo*
    constptr_WebAuthnGetAssertionExtraInfo() const
    {
        return ((mValue).VWebAuthnGetAssertionExtraInfo).addr();
    }
    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT WebAuthnMaybeGetAssertionExtraInfo() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT WebAuthnMaybeGetAssertionExtraInfo(const WebAuthnGetAssertionExtraInfo& aOther);

    MOZ_IMPLICIT WebAuthnMaybeGetAssertionExtraInfo(WebAuthnGetAssertionExtraInfo&& aOther);

    MOZ_IMPLICIT WebAuthnMaybeGetAssertionExtraInfo(const null_t& aOther);

    MOZ_IMPLICIT WebAuthnMaybeGetAssertionExtraInfo(null_t&& aOther);

    MOZ_IMPLICIT WebAuthnMaybeGetAssertionExtraInfo(const WebAuthnMaybeGetAssertionExtraInfo& aOther);

    MOZ_IMPLICIT WebAuthnMaybeGetAssertionExtraInfo(WebAuthnMaybeGetAssertionExtraInfo&& aOther);

    ~WebAuthnMaybeGetAssertionExtraInfo();

    Type
    type() const
    {
        return mType;
    }

    WebAuthnMaybeGetAssertionExtraInfo&
    operator=(const WebAuthnGetAssertionExtraInfo& aRhs);

    WebAuthnMaybeGetAssertionExtraInfo&
    operator=(WebAuthnGetAssertionExtraInfo&& aRhs);

    WebAuthnMaybeGetAssertionExtraInfo&
    operator=(const null_t& aRhs);

    WebAuthnMaybeGetAssertionExtraInfo&
    operator=(null_t&& aRhs);

    WebAuthnMaybeGetAssertionExtraInfo&
    operator=(const WebAuthnMaybeGetAssertionExtraInfo& aRhs);

    WebAuthnMaybeGetAssertionExtraInfo&
    operator=(WebAuthnMaybeGetAssertionExtraInfo&& aRhs);

    bool
    operator==(const WebAuthnGetAssertionExtraInfo& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const WebAuthnMaybeGetAssertionExtraInfo& aRhs) const;

    WebAuthnGetAssertionExtraInfo&
    get_WebAuthnGetAssertionExtraInfo()
    {
        AssertSanity(TWebAuthnGetAssertionExtraInfo);
        return (*(ptr_WebAuthnGetAssertionExtraInfo()));
    }
    const WebAuthnGetAssertionExtraInfo&
    get_WebAuthnGetAssertionExtraInfo() const
    {
        AssertSanity(TWebAuthnGetAssertionExtraInfo);
        return (*(constptr_WebAuthnGetAssertionExtraInfo()));
    }
    void
    get(WebAuthnGetAssertionExtraInfo* aOutValue) const;
    operator WebAuthnGetAssertionExtraInfo&()
    {
        return get_WebAuthnGetAssertionExtraInfo();
    }
    operator const WebAuthnGetAssertionExtraInfo&() const
    {
        return get_WebAuthnGetAssertionExtraInfo();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    void
    get(null_t* aOutValue) const;
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnMaybeGetAssertionExtraInfo>
{
    typedef mozilla::dom::WebAuthnMaybeGetAssertionExtraInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnGetAssertionInfo|
//
namespace mozilla {
namespace dom {
class WebAuthnGetAssertionInfo final
{
private:
    typedef mozilla::dom::WebAuthnScopedCredential WebAuthnScopedCredential;
    typedef mozilla::dom::WebAuthnMaybeGetAssertionExtraInfo WebAuthnMaybeGetAssertionExtraInfo;

public:
    MOZ_IMPLICIT WebAuthnGetAssertionInfo() :
        Origin_(),
        RpId_(),
        Challenge_(),
        ClientDataJSON_(),
        TimeoutMS_(),
        AllowList_(),
        Extra_()
    {
    }

    MOZ_IMPLICIT WebAuthnGetAssertionInfo(
            const nsString& _Origin,
            const nsString& _RpId,
            const nsTArray<uint8_t>& _Challenge,
            const nsCString& _ClientDataJSON,
            const uint32_t& _TimeoutMS,
            const nsTArray<WebAuthnScopedCredential>& _AllowList,
            const WebAuthnMaybeGetAssertionExtraInfo& _Extra) :
        Origin_(_Origin),
        RpId_(_RpId),
        Challenge_(_Challenge),
        ClientDataJSON_(_ClientDataJSON),
        TimeoutMS_(_TimeoutMS),
        AllowList_(_AllowList),
        Extra_(_Extra)
    {
    }

    bool
    operator==(const WebAuthnGetAssertionInfo& _o) const;

    bool
    operator!=(const WebAuthnGetAssertionInfo& _o) const;

    nsString&
    Origin()
    {
        return Origin_;
    }
    const nsString&
    Origin() const
    {
        return Origin_;
    }

    nsString&
    RpId()
    {
        return RpId_;
    }
    const nsString&
    RpId() const
    {
        return RpId_;
    }

    nsTArray<uint8_t>&
    Challenge()
    {
        return Challenge_;
    }
    const nsTArray<uint8_t>&
    Challenge() const
    {
        return Challenge_;
    }

    nsCString&
    ClientDataJSON()
    {
        return ClientDataJSON_;
    }
    const nsCString&
    ClientDataJSON() const
    {
        return ClientDataJSON_;
    }

    uint32_t&
    TimeoutMS()
    {
        return TimeoutMS_;
    }
    const uint32_t&
    TimeoutMS() const
    {
        return TimeoutMS_;
    }

    nsTArray<WebAuthnScopedCredential>&
    AllowList()
    {
        return AllowList_;
    }
    const nsTArray<WebAuthnScopedCredential>&
    AllowList() const
    {
        return AllowList_;
    }

    WebAuthnMaybeGetAssertionExtraInfo&
    Extra()
    {
        return Extra_;
    }
    const WebAuthnMaybeGetAssertionExtraInfo&
    Extra() const
    {
        return Extra_;
    }

private:
    nsString Origin_;
    nsString RpId_;
    nsTArray<uint8_t> Challenge_;
    nsCString ClientDataJSON_;
    uint32_t TimeoutMS_;
    nsTArray<WebAuthnScopedCredential> AllowList_;
    WebAuthnMaybeGetAssertionExtraInfo Extra_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnGetAssertionInfo>
{
    typedef mozilla::dom::WebAuthnGetAssertionInfo paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct WebAuthnGetAssertionResult|
//
namespace mozilla {
namespace dom {
class WebAuthnGetAssertionResult final
{
private:
    typedef mozilla::dom::WebAuthnExtensionResult WebAuthnExtensionResult;

public:
    MOZ_IMPLICIT WebAuthnGetAssertionResult() :
        ClientDataJSON_(),
        KeyHandle_(),
        Signature_(),
        AuthenticatorData_(),
        Extensions_(),
        SignatureData_()
    {
    }

    MOZ_IMPLICIT WebAuthnGetAssertionResult(
            const nsCString& _ClientDataJSON,
            const nsTArray<uint8_t>& _KeyHandle,
            const nsTArray<uint8_t>& _Signature,
            const nsTArray<uint8_t>& _AuthenticatorData,
            const nsTArray<WebAuthnExtensionResult>& _Extensions,
            const nsTArray<uint8_t>& _SignatureData) :
        ClientDataJSON_(_ClientDataJSON),
        KeyHandle_(_KeyHandle),
        Signature_(_Signature),
        AuthenticatorData_(_AuthenticatorData),
        Extensions_(_Extensions),
        SignatureData_(_SignatureData)
    {
    }

    bool
    operator==(const WebAuthnGetAssertionResult& _o) const;

    bool
    operator!=(const WebAuthnGetAssertionResult& _o) const;

    nsCString&
    ClientDataJSON()
    {
        return ClientDataJSON_;
    }
    const nsCString&
    ClientDataJSON() const
    {
        return ClientDataJSON_;
    }

    nsTArray<uint8_t>&
    KeyHandle()
    {
        return KeyHandle_;
    }
    const nsTArray<uint8_t>&
    KeyHandle() const
    {
        return KeyHandle_;
    }

    nsTArray<uint8_t>&
    Signature()
    {
        return Signature_;
    }
    const nsTArray<uint8_t>&
    Signature() const
    {
        return Signature_;
    }

    nsTArray<uint8_t>&
    AuthenticatorData()
    {
        return AuthenticatorData_;
    }
    const nsTArray<uint8_t>&
    AuthenticatorData() const
    {
        return AuthenticatorData_;
    }

    nsTArray<WebAuthnExtensionResult>&
    Extensions()
    {
        return Extensions_;
    }
    const nsTArray<WebAuthnExtensionResult>&
    Extensions() const
    {
        return Extensions_;
    }

    nsTArray<uint8_t>&
    SignatureData()
    {
        return SignatureData_;
    }
    const nsTArray<uint8_t>&
    SignatureData() const
    {
        return SignatureData_;
    }

private:
    nsCString ClientDataJSON_;
    nsTArray<uint8_t> KeyHandle_;
    nsTArray<uint8_t> Signature_;
    nsTArray<uint8_t> AuthenticatorData_;
    nsTArray<WebAuthnExtensionResult> Extensions_;
    nsTArray<uint8_t> SignatureData_;
};
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::WebAuthnGetAssertionResult>
{
    typedef mozilla::dom::WebAuthnGetAssertionResult paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {
class PWebAuthnTransactionParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PWebAuthnTransactionChild;
} // namespace dom
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PWebAuthnTransactionChild and PWebAuthnTransactionParent
//
namespace mozilla {
namespace dom {
namespace PWebAuthnTransaction {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::dom::PWebAuthnTransactionParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::dom::PWebAuthnTransactionChild>* aChild);

enum MessageType {
    PWebAuthnTransactionStart = PWebAuthnTransactionMsgStart << 16,
    Msg_RequestRegister__ID,
    Msg_RequestSign__ID,
    Msg_RequestCancel__ID,
    Msg_DestroyMe__ID,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_ConfirmRegister__ID,
    Msg_ConfirmSign__ID,
    Msg_Abort__ID,
    PWebAuthnTransactionEnd
};

IPC::Message*
Msg_RequestRegister(int32_t routingId);

IPC::Message*
Msg_RequestSign(int32_t routingId);

IPC::Message*
Msg_RequestCancel(int32_t routingId);

IPC::Message*
Msg_DestroyMe(int32_t routingId);

IPC::Message*
Msg___delete__(int32_t routingId);
IPC::Message*
Reply___delete__(int32_t routingId);

IPC::Message*
Msg_ConfirmRegister(int32_t routingId);

IPC::Message*
Msg_ConfirmSign(int32_t routingId);

IPC::Message*
Msg_Abort(int32_t routingId);



} // namespace PWebAuthnTransaction
} // namespace dom
} // namespace mozilla

#endif // ifndef PWebAuthnTransaction_h
