//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PVRParent_h
#define PVRParent_h

#include "mozilla/gfx/PVR.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

#include "mozilla/ipc/ProtocolUtils.h"

class nsIFile;

// Headers for things that cannot be forward declared
#include "mozilla/TimeStamp.h"

namespace mozilla {
namespace gfx {
class PVRGPUParent;
} // namespace gfx
} // namespace mozilla
namespace mozilla {
namespace gfx {
class PVRGPUChild;
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {


class PVRParent :
    public mozilla::ipc::IToplevelProtocol
{
private:
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::gfx::BackendType BackendType;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::gfx::ContentDeviceData ContentDeviceData;
    typedef mozilla::gfx::D3D11DeviceStatus D3D11DeviceStatus;
    typedef mozilla::gfx::DevicePrefs DevicePrefs;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::gfx::FeatureChange FeatureChange;
    typedef mozilla::gfx::FeatureFailure FeatureFailure;
    typedef mozilla::gfx::FeatureStatus FeatureStatus;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::gfx::GPUDeviceData GPUDeviceData;
    typedef mozilla::gfx::GPUDeviceStatus GPUDeviceStatus;
    typedef mozilla::gfx::GfxPrefSetting GfxPrefSetting;
    typedef mozilla::gfx::GfxPrefValue GfxPrefValue;
    typedef mozilla::gfx::GfxVarUpdate GfxVarUpdate;
    typedef mozilla::gfx::GfxVarValue GfxVarValue;
    typedef mozilla::gfx::IntSize IntSize;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::TimeStamp TimeStamp;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::null_t null_t;
    typedef mozilla::gfx::PVRGPUParent PVRGPUParent;
    typedef mozilla::gfx::PVRGPUChild PVRGPUChild;

protected:
    virtual mozilla::ipc::IPCResult
    RecvNewGPUVRManager(Endpoint<mozilla::gfx::PVRGPUParent>&& endpoint) = 0;
    virtual mozilla::ipc::IPCResult
    RecvInit(
            nsTArray<GfxPrefSetting>&& prefs,
            nsTArray<GfxVarUpdate>&& vars,
            const DevicePrefs& devicePrefs) = 0;
    virtual mozilla::ipc::IPCResult
    RecvNotifyVsync(const TimeStamp& vsyncTimestamp) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdatePref(const GfxPrefSetting& pref) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdateVar(const GfxVarUpdate& var) = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

    void
    ProcessingError(
            Result aCode,
            const char* aReason) override;
    bool
    ShouldContinueFromReplyTimeout() override;
    void
    EnteredCxxStack() override;
    void
    ExitedCxxStack() override;
    void
    EnteredCall() override;
    void
    ExitedCall() override;

public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PVRParent();

    virtual ~PVRParent();

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

    void
    OnChannelClose() override;

    void
    OnChannelError() override;

private:
    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    virtual void
    DeallocPVRParent();

    mozilla::ipc::LivenessState mLivenessState;
};


} // namespace gfx
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::gfx::PVRParent>
{
    typedef mozilla::gfx::PVRParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace gfx {
class VRParent :
    public PVRParent
{
    mozilla::ipc::IPCResult
    RecvNewGPUVRManager(Endpoint<mozilla::gfx::PVRGPUParent>&& endpoint) override;

    mozilla::ipc::IPCResult
    RecvInit(
            nsTArray<GfxPrefSetting>&& prefs,
            nsTArray<GfxVarUpdate>&& vars,
            const DevicePrefs& devicePrefs) override;

    mozilla::ipc::IPCResult
    RecvNotifyVsync(const TimeStamp& vsyncTimestamp) override;

    mozilla::ipc::IPCResult
    RecvUpdatePref(const GfxPrefSetting& pref) override;

    mozilla::ipc::IPCResult
    RecvUpdateVar(const GfxVarUpdate& var) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT VRParent();
    virtual ~VRParent();
};
} // namespace gfx
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace gfx {
mozilla::ipc::IPCResult
VRParent::RecvNewGPUVRManager(Endpoint<mozilla::gfx::PVRGPUParent>&& endpoint)
{
}

mozilla::ipc::IPCResult
VRParent::RecvInit(
        nsTArray<GfxPrefSetting>&& prefs,
        nsTArray<GfxVarUpdate>&& vars,
        const DevicePrefs& devicePrefs)
{
}

mozilla::ipc::IPCResult
VRParent::RecvNotifyVsync(const TimeStamp& vsyncTimestamp)
{
}

mozilla::ipc::IPCResult
VRParent::RecvUpdatePref(const GfxPrefSetting& pref)
{
}

mozilla::ipc::IPCResult
VRParent::RecvUpdateVar(const GfxVarUpdate& var)
{
}

void
VRParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT VRParent::VRParent()
{
    MOZ_COUNT_CTOR(VRParent);
}

MOZ_IMPLICIT VRParent::~VRParent()
{
    MOZ_COUNT_DTOR(VRParent);
}

} // namespace gfx
} // namespace mozilla
#endif // if 0

#endif // ifndef PVRParent_h
